﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Net;
using System.Security.Cryptography;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Xml;
using uPLibrary.Networking.M2Mqtt;
using uPLibrary.Networking.M2Mqtt.Messages;

namespace smartDEN_IP_16R_MQ_Demo
{
    

    public partial class Form1 : Form
    {
        public MqttClient client;        
        public static MqttObject mqtt = new MqttObject();


        public class MqttObject
        {
            String notification;
            String dateTime;
            String name;
            String xmlString;
            bool mustSetRelay=false;
            int relN;
            bool relState;
            String topic1;
            String topic2;
            String notifTopic;
            String[] relayStates = new String[16];

            public string Notification { get => notification; set => notification = value; }
            public string DateTime { get => dateTime; set => dateTime = value; }
            public string Name { get => name; set => name = value; }
            public string XmlString { get => xmlString; set => xmlString = value; }
            public bool MustSetRelay { get => mustSetRelay; set => mustSetRelay = value; }
            public int RelN { get => relN; set => relN = value; }
            public bool RelState { get => relState; set => relState = value; } 
            public string Topic1 { get => topic1; set => topic1 = value; }
            public string Topic2 { get => topic2; set => topic2 = value; }
            public string NotifTopic { get => notifTopic; set => notifTopic = value; }
            public String[] RelayStates { get => relayStates; set => relayStates = value; }

            public void setRelay(bool encrypted, int RelN, bool RelState)
            {
                MustSetRelay = true; 
                this.RelN = RelN;
                this.RelState = RelState;
            }
        }

        static void client_MqttMsgPublishReceived(object sender, MqttMsgPublishEventArgs e)
        {
            Debug.WriteLine(Encoding.UTF8.GetString(e.Message));

            if (e.Topic.Contains("Get"))
            {//Non-encrypted
                if (e.Topic.Contains("Get/R"))
                {
                    int size = e.Topic.Split('/').Length;
                    int relN = int.Parse((e.Topic.Split('/')[size - 1]).Replace("R",""));
                    String state = "0";
                    if (Encoding.UTF8.GetString(e.Message) == "On") state = "1";
                    mqtt.RelayStates[relN-1] = state;
                }
            }
            else
            {//Encrypted              
                if (e.Topic == mqtt.NotifTopic)
                {
                    mqtt.Notification = (Encoding.UTF8.GetString(e.Message).Split('>')[0]);
                    mqtt.DateTime = (Encoding.UTF8.GetString(e.Message).Split('>')[2]);
                    mqtt.Name = (Encoding.UTF8.GetString(e.Message).Split('>')[1]);
                }
                else if (e.Topic == mqtt.Topic1)
                {
                    mqtt.XmlString = (Encoding.UTF8.GetString(e.Message));
                }
            }
           
        }

        public Form1()
        {
            InitializeComponent();
        }
        
        public static string CreateMD5(string input)
        {
            // Use input string to calculate MD5 hash
            using (System.Security.Cryptography.MD5 md5 = System.Security.Cryptography.MD5.Create())
            {
                byte[] inputBytes = System.Text.Encoding.ASCII.GetBytes(input);
                byte[] hashBytes = md5.ComputeHash(inputBytes);

                // Convert the byte array to hexadecimal string
                StringBuilder sb = new StringBuilder();
                for (int i = 0; i < hashBytes.Length; i++)
                {
                    sb.Append(hashBytes[i].ToString("X2"));
                }
                return sb.ToString();
            }
        }

        public void setRelay(int relN, Boolean relState)
        {
            mqtt.RelN = relN;
            mqtt.RelState = relState;
            mqtt.MustSetRelay = true;

            ////String strValue = "0";
            //if (relState) strValue = "1";
            //if (encrypted.Checked)
            //{//Encrypted mode 
            //    String topic = CreateMD5(MAC.Text + user.Text + "read" + pass.Text).ToLower();
            //    client.Publish(topic, Encoding.UTF8.GetBytes("MQTT_COMMAND?RSX"+relN.ToString()+"="+strValue+";"));
            //}
            //else
            //{//Non-encrypted mode
            //    client.Publish("SmartDEN_MQTT16R/"+MAC.Text+"/Set/RS"+relN.ToString(), Encoding.UTF8.GetBytes(strValue));
            //}            
        }

        private void GroupBox1_Enter(object sender, EventArgs e)
        {

        }

        private void Button1_Click(object sender, EventArgs e)
        {
            toolStripStatusLabel1.Text = "Connecting...";
            client = new MqttClient(MQTTBrokerName.Text, Convert.ToInt32(MqttPort.Text), false, null, null, MqttSslProtocols.None);
            string clientId = Guid.NewGuid().ToString();
            client.Connect(clientId);

            if (client.IsConnected)
            {
                toolStripStatusLabel1.Text = "Connected to " + MQTTBrokerName.Text + ":" + MqttPort.Text;
                button1.Enabled = false;
                button2.Enabled = true;
                connGroup.Enabled = false;

                client.MqttMsgPublishReceived += client_MqttMsgPublishReceived;

                if (encrypted.Checked)
                {//Encrypted mode 
                    
                    groupBox2.Enabled = true;
                    mqtt.Topic1 = CreateMD5(MAC.Text + user.Text + "write" + pass.Text).ToLower();
                    mqtt.Topic2 = CreateMD5(MAC.Text + user.Text + "read" + pass.Text).ToLower();
                    mqtt.NotifTopic = CreateMD5(MAC.Text + user.Text + "notifications" + pass.Text).ToLower();

                    client.Subscribe(new string[] { mqtt.Topic1 } , new byte[] { MqttMsgBase.QOS_LEVEL_AT_MOST_ONCE });
                    client.Subscribe(new string[] { mqtt.NotifTopic }, new byte[] { MqttMsgBase.QOS_LEVEL_EXACTLY_ONCE });
                    

                }
                else
                {//Non-encrypted mode

                    groupBox2.Enabled = false;
                    client.Subscribe(new string[] { "SmartDEN_MQTT16R/"+ MAC.Text + "/Get/#" }, new byte[] { MqttMsgBase.QOS_LEVEL_EXACTLY_ONCE });
                }

                timer1.Enabled = true;
            }
            else
                toolStripStatusLabel1.Text = "Unable to connect to " + MQTTBrokerName.Text + ":" + MqttPort.Text;
           
        }

    
        private void Button2_Click(object sender, EventArgs e)
        {
            client.Disconnect();
            toolStripStatusLabel1.Text = "Disconnected from " + MQTTBrokerName.Text + ":" + MqttPort.Text;
            button2.Enabled = false;
            button1.Enabled = true;
            connGroup.Enabled = true;
            timer1.Enabled = false;
            groupBox2.Enabled = true;
        }

        private void ToolStripStatusLabel1_Click(object sender, EventArgs e)
        {

        }

        private void CheckBox5_CheckedChanged(object sender, EventArgs e)
        {
          
        }

        private void CheckBox1_CheckedChanged(object sender, EventArgs e)
        {
            setRelay(1,checkBox1.Checked);
        }

        private void CheckBox2_CheckedChanged(object sender, EventArgs e)
        {
            setRelay(2, checkBox2.Checked);
        }

        private void CheckBox3_CheckedChanged(object sender, EventArgs e)
        {
            setRelay(3, checkBox3.Checked);
        }

        private void CheckBox4_CheckedChanged(object sender, EventArgs e)
        {
            setRelay(4, checkBox4.Checked);
        }

        private void CheckBox6_CheckedChanged(object sender, EventArgs e)
        {
            setRelay(5, checkBox6.Checked);
        }

        private void CheckBox7_CheckedChanged(object sender, EventArgs e)
        {
            setRelay(6, checkBox7.Checked);
        }

        private void CheckBox8_CheckedChanged(object sender, EventArgs e)
        {
            setRelay(7, checkBox8.Checked);
        }

        private void CheckBox9_CheckedChanged(object sender, EventArgs e)
        {
            setRelay(8, checkBox9.Checked);
        }

        private void RichTextBox1_TextChanged(object sender, EventArgs e)
        {

        }

        private void Button3_Click(object sender, EventArgs e)
        {
           

             
        }

        public void updateGUI()
        {
            
        }

        private void Timer1_Tick(object sender, EventArgs e)
        {
            richTextBox1.Text = mqtt.Notification;
            tbDateTime.Text = mqtt.DateTime;
            tbDeviceName.Text = mqtt.Name;

            if (client.IsConnected)
            {
                if (encrypted.Checked)
                {//Encrypted mode 
                    if (mqtt.MustSetRelay)
                    {//Set Relay
                        mqtt.MustSetRelay = false;
                        String state = "0";
                        if (mqtt.RelState) state = "1";
                        client.Publish(mqtt.Topic2, Encoding.UTF8.GetBytes("MQTT_COMMAND?RSX" + mqtt.RelN.ToString() + "=" + state + ";"));
                    }
                    else
                    {
                        client.Publish(mqtt.Topic2, Encoding.UTF8.GetBytes("MQTT_COMMAND?GETSTATUS;"));
                    }
                    
                }
                else
                {//Non-encrypted mode
                    if (mqtt.MustSetRelay)
                    {//Set Relay
                        mqtt.MustSetRelay = false;
                        String state = "0";
                        if (mqtt.RelState) state = "1";
                        client.Publish("SmartDEN_MQTT16R/"+MAC.Text+"/Set/RS" + mqtt.RelN.ToString(), Encoding.UTF8.GetBytes(state));
                    }
                    else
                    {
                        client.Publish("SmartDEN_MQTT16R/" + MAC.Text + "/Set/GETSTATUS", Encoding.UTF8.GetBytes(""));
                    }
                }

                //Refresh States
                if (encrypted.Checked)
                {
                    if (mqtt.XmlString != null)
                    {
                        XmlDocument xmlDoc = new XmlDocument();
                        xmlDoc.LoadXml(mqtt.XmlString);

                        mqtt.RelayStates[0] = xmlDoc.DocumentElement.SelectSingleNode("/CurrentState/Relay1/State").InnerText;
                        mqtt.RelayStates[1] = xmlDoc.DocumentElement.SelectSingleNode("/CurrentState/Relay2/State").InnerText;
                        mqtt.RelayStates[2] = xmlDoc.DocumentElement.SelectSingleNode("/CurrentState/Relay3/State").InnerText;
                        mqtt.RelayStates[3] = xmlDoc.DocumentElement.SelectSingleNode("/CurrentState/Relay4/State").InnerText;
                        mqtt.RelayStates[4] = xmlDoc.DocumentElement.SelectSingleNode("/CurrentState/Relay5/State").InnerText;
                        mqtt.RelayStates[5] = xmlDoc.DocumentElement.SelectSingleNode("/CurrentState/Relay6/State").InnerText;
                        mqtt.RelayStates[6] = xmlDoc.DocumentElement.SelectSingleNode("/CurrentState/Relay7/State").InnerText;
                        mqtt.RelayStates[7] = xmlDoc.DocumentElement.SelectSingleNode("/CurrentState/Relay8/State").InnerText;
                        mqtt.RelayStates[8] = xmlDoc.DocumentElement.SelectSingleNode("/CurrentState/Relay9/State").InnerText;
                        mqtt.RelayStates[9] = xmlDoc.DocumentElement.SelectSingleNode("/CurrentState/Relay10/State").InnerText;
                        mqtt.RelayStates[10] = xmlDoc.DocumentElement.SelectSingleNode("/CurrentState/Relay11/State").InnerText;
                        mqtt.RelayStates[11] = xmlDoc.DocumentElement.SelectSingleNode("/CurrentState/Relay12/State").InnerText;
                        mqtt.RelayStates[12] = xmlDoc.DocumentElement.SelectSingleNode("/CurrentState/Relay13/State").InnerText;
                        mqtt.RelayStates[13] = xmlDoc.DocumentElement.SelectSingleNode("/CurrentState/Relay14/State").InnerText;
                        mqtt.RelayStates[14] = xmlDoc.DocumentElement.SelectSingleNode("/CurrentState/Relay15/State").InnerText;
                        mqtt.RelayStates[15] = xmlDoc.DocumentElement.SelectSingleNode("/CurrentState/Relay16/State").InnerText;
                    }
                }

                state1.Text = mqtt.RelayStates[0];
                state2.Text = mqtt.RelayStates[1];
                state3.Text = mqtt.RelayStates[2];
                state4.Text = mqtt.RelayStates[3];
                state5.Text = mqtt.RelayStates[4];
                state6.Text = mqtt.RelayStates[5];
                state7.Text = mqtt.RelayStates[6];
                state8.Text = mqtt.RelayStates[7];
                state9.Text = mqtt.RelayStates[8];
                state10.Text = mqtt.RelayStates[9];
                state11.Text = mqtt.RelayStates[10];
                state12.Text = mqtt.RelayStates[11];
                state13.Text = mqtt.RelayStates[12];
                state14.Text = mqtt.RelayStates[13];
                state15.Text = mqtt.RelayStates[14];
                state16.Text = mqtt.RelayStates[15];
 

            }
        }

        private void CheckBox10_CheckedChanged(object sender, EventArgs e)
        {
            setRelay(9, checkBox10.Checked);
        }

        private void CheckBox11_CheckedChanged(object sender, EventArgs e)
        {
            setRelay(10, checkBox11.Checked);
        }

        private void CheckBox12_CheckedChanged(object sender, EventArgs e)
        {
            setRelay(11, checkBox12.Checked);
        }

        private void CheckBox13_CheckedChanged(object sender, EventArgs e)
        {
            setRelay(12, checkBox13.Checked);
        }

        private void CheckBox14_CheckedChanged(object sender, EventArgs e)
        {
            setRelay(13, checkBox14.Checked);
        }

        private void CheckBox15_CheckedChanged(object sender, EventArgs e)
        {
            setRelay(14, checkBox15.Checked);
        }

        private void CheckBox16_CheckedChanged(object sender, EventArgs e)
        {
            setRelay(15, checkBox16.Checked);
        }

        private void CheckBox17_CheckedChanged(object sender, EventArgs e)
        {
            setRelay(16, checkBox17.Checked);
        }
    }
}
